Utils.insertCSS ".dimmed {opacity: 0.4;}"

## GRID ##
grid.props =
	image: "images/gridlines.png"
	style:
		backgroundPosition: "0px 0px"
		backgroundRepeat: "repeat"
		backgroundSize: "auto"

## LAYERS ##
layerB_left = new VideoLayer 
	width: 320
	height: 180
	video: "images/Traffic in Times Square.mp4"
	parent: layerB_left_container
layerB_left.player.loop = yes

layerB_right = layerB_left.copy()
layerB_right.x = -160
layerB_right.y = 30
layerB_right.parent = layerB_right_container
layerB_right.player.loop = yes

Utils.delay 1, ->
	layerB_left.player.play()
	layerB_right.player.play()


layerC_right = layerC_left.copy()
layerC_right.x = -80
layerC_right.y = 30
layerC_right.parent = layerC_right_container


filteredLayers = [layerA_right, layerB_right, layerC_right]

## LEFT SLIDERS ##
slider_1_label = new Layer
	html: "<span class=\"dimmed\">layer.</span>blur"

slider_1 = new SliderComponent 
	min: 0
	max: 50

slider_1.onValueChange -> 
	for layer in filteredLayers
		layer.blur = this.value
	
slider_1_value = new Layer


slider_2_label = new Layer
	html: "<span class=\"dimmed\">layer.</span>brightness"

slider_2 = new SliderComponent 
	min: 0
	max: 200

slider_2.onValueChange -> 
	for layer in filteredLayers
		layer.brightness = this.value
		
slider_2_value = new Layer


slider_3_label = new Layer
	html: "<span class=\"dimmed\">layer.</span>contrast"

slider_3 = new SliderComponent 
	min: 0
	max: 200

slider_3.onValueChange ->
	for layer in filteredLayers
		layer.contrast = this.value

slider_3_value = new Layer


slider_4_label = new Layer
	html: "<span class=\"dimmed\">layer.</span>saturate"

slider_4 = new SliderComponent 
	min: 0
	max: 200

slider_4.onValueChange ->
	for layer in filteredLayers
		layer.saturate = this.value

slider_4_value = new Layer


allLabelsA = [slider_1_label, slider_2_label, slider_3_label, slider_4_label]
allSlidersA = [slider_1,slider_2,slider_3,slider_4]
allValuesA = [slider_1_value, slider_2_value, slider_3_value, slider_4_value]


# Loop over labels
for i in [0..3]
	allLabelsA[i].props =
		width: 190
		height: 35
		backgroundColor: null
		x: 50
		y: grid.maxY + 40 + (i*50)
		style:
			fontFamily: "Menlo,Monaco,Courier,monospace"
			fontSize: "19px"
			lineHeight: "25px"

# Loop over sliders and their values
for i in [0..3]
	# Sliders
	allSlidersA[i].props =
		width: 200
		height: 5
		x: allLabelsA[i].maxX + 13
		y: grid.maxY + 45 + (i*50)
	
	allSlidersA[i].fill.backgroundColor = "rgba(255,255,255,0.7)"
	allSlidersA[i].knobSize = 25
	allSlidersA[i].knob.borderRadius = 13
	allSlidersA[i].knob.backgroundColor = "rgba(255,255,255,1)"
	allSlidersA[i].backgroundColor = "rgba(255,255,255,0.3)"
	
	# Values
	allValuesA[i].props =
		width: 50
		height: 25
		backgroundColor: null
		x: allSlidersA[i].maxX + 20
		y: grid.maxY + 40 + (i*50)
		style:
			fontFamily: "Menlo,Monaco,Courier,monospace"
			fontSize: "19px"
			lineHeight: "25px"

## RIGHT SLIDERS ##
slider_5_label = new Layer
	html: "<span class=\"dimmed\">layer.</span>grayscale"

slider_5 = new SliderComponent 
	min: 0
	max: 100

slider_5.onValueChange -> 
	for layer in filteredLayers
		layer.grayscale = this.value

slider_5_value = new Layer


slider_6_label = new Layer
	html: "<span class=\"dimmed\">layer.</span>hueRotate"

slider_6 = new SliderComponent 
	min: 0
	max: 360

slider_6.onValueChange -> 
	for layer in filteredLayers
		layer.hueRotate = this.value	
		
slider_6_value = new Layer


slider_7_label = new Layer
	html: "<span class=\"dimmed\">layer.</span>invert"

slider_7 = new SliderComponent 
	min: 0
	max: 100

slider_7.onValueChange -> 
	for layer in filteredLayers
		layer.invert = this.value

slider_7_value = new Layer


slider_8_label = new Layer
	html: "<span class=\"dimmed\">layer.</span>sepia"

slider_8 = new SliderComponent 
	min: 0
	max: 100

slider_8.onValueChange -> 
	for layer in filteredLayers
		layer.sepia = this.value

slider_8_value = new Layer


allLabelsB = [slider_5_label, slider_6_label, slider_7_label, slider_8_label]
allSlidersB = [slider_5,slider_6,slider_7,slider_8]
allValuesB = [slider_5_value, slider_6_value, slider_7_value, slider_8_value]


# Loop over labels
for i in [0..3]
	allLabelsB[i].props =
		width: 180
		height: 35
		backgroundColor: null
		x: 531 + 10
		y: grid.maxY + 40 + (i*50)
		style:
			fontFamily: "Menlo,Monaco,Courier,monospace"
			fontSize: "19px"
			lineHeight: "25px"


# Loop over sliders and their values
for i in [0..3]
	# Sliders
	allSlidersB[i].props =
		width: 200
		height: 5
		x: allLabelsB[i].maxX + 13
		y: grid.maxY + 45 + (i*50)
	
	allSlidersB[i].fill.backgroundColor = "rgba(255,255,255,0.7)"
	allSlidersB[i].knobSize = 25
	allSlidersB[i].knob.borderRadius = 13
	allSlidersB[i].knob.backgroundColor = "rgba(255,255,255,1)"
	allSlidersB[i].backgroundColor = "rgba(255,255,255,0.3)"
	
	# Values
	allValuesB[i].props =
		width: 50
		height: 25
		backgroundColor: null
		x: allSlidersB[i].maxX + 20
		y: grid.maxY + 40 + (i*50)
		style:
			fontFamily: "Menlo,Monaco,Courier,monospace"
			fontSize: "19px"
			lineHeight: "25px"

## RESET BUTTON ##
button_reset = new Layer
	width: 200
	height: 40
	borderRadius: 25
	backgroundColor: "white"
	x: Align.center
	maxY: Screen.height - 45
	color: "black"
	html: "Reset layers"
	style:
		fontFamily: Title.fontFamily
		fontWeight: 300
		fontSize: "22px"
		lineHeight: "76px"
		textAlign: "center"

button_reset.onTapStart ->
	@backgroundColor = "rgba(153,153,153,1)"
button_reset.onTap ->
	@backgroundColor = "white"
	for layer in filteredLayers
		layer.animate
			blur: 0
			brightness: 100
			contrast: 100
			saturate: 100
			grayscale: 0
			hueRotate: 0
			invert: 0
			sepia: 0

## CHANGE EVENTS ##
layerA_right.on "change:blur", ->
	slider_1.value = this.blur
	slider_1_value.html = "#{Utils.round(this.blur)}"

layerA_right.on "change:brightness", ->
	slider_2.value = this.brightness
	slider_2_value.html = "#{Utils.round(this.brightness)}"

layerA_right.on "change:contrast", ->
	slider_3.value = this.contrast
	slider_3_value.html = "#{Utils.round(this.contrast)}"
	
layerA_right.on "change:saturate", ->
	slider_4.value = this.saturate
	slider_4_value.html = "#{Utils.round(this.saturate)}"

layerA_right.on "change:grayscale", ->
	slider_5.value = this.grayscale
	slider_5_value.html = "#{Utils.round(this.grayscale)}"

layerA_right.on "change:hueRotate", ->
	slider_6.value = this.hueRotate
	slider_6_value.html = "#{Utils.round(this.hueRotate)}"

layerA_right.on "change:invert", ->
	slider_7.value = this.invert
	slider_7_value.html = "#{Utils.round(this.invert)}"

layerA_right.on "change:sepia", ->
	slider_8.value = this.sepia
	slider_8_value.html = "#{Utils.round(this.sepia)}"

## AFTER LOADING ##
slider_1.value = layerA_right.blur
slider_1_value.html = "#{Utils.round(layerA_right.blur)}"
slider_2.value = layerA_right.brightness
slider_2_value.html = "#{Utils.round(layerA_right.brightness)}"
slider_3.value = layerA_right.contrast
slider_3_value.html = "#{Utils.round(layerA_right.contrast)}"
slider_4.value = layerA_right.saturate
slider_4_value.html = "#{Utils.round(layerA_right.saturate)}"

slider_5.value = layerA_right.grayscale
slider_5_value.html = "#{Utils.round(layerA_right.grayscale)}"
slider_6.value = layerA_right.hueRotate
slider_6_value.html = "#{Utils.round(layerA_right.hueRotate)}"
slider_7.value = layerA_right.invert
slider_7_value.html = "#{Utils.round(layerA_right.invert)}"
slider_8.value = layerA_right.sepia
slider_8_value.html = "#{Utils.round(layerA_right.sepia)}"
